# File: Font.py
#
# Copyright (c) 2006 by Atopia VOF, Netherlands, http://www.atopia.nl
# Generator: ArchGenXML Version 1.4.1
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Atopia <info@atopia.nl>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.TextImage.config import *


##code-section module-header #fill in your manual code here
import os
from Products.CMFCore.utils import getToolByName
from zLOG import LOG, DEBUG, INFO, WARNING, ERROR
##/code-section module-header

schema = Schema((

    FileField(
        name='File',
        widget=FileWidget(
            label='File',
            label_msgid='TextImage_label_File',
            description_msgid='TextImage_help_File',
            i18n_domain='TextImage',
        ),
        required=1,
        storage=AttributeStorage()
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Font_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
Font_schema["title"].widget.visible = {"view" : "invisible", "edit" : "invisible"}
Font_schema["title"].required = 0
Font_schema["description"].widget.visible = {"view" : "invisible", "edit" : "invisible"}
##/code-section after-schema

class Font(BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Font'

    meta_type = 'Font'
    portal_type = 'Font'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    allow_discussion = False
    content_icon = 'Font.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "Font"
    typeDescMsgId = 'description_edit_font'

    schema = Font_schema

    ##code-section class-header #fill in your manual code here
    def setID(self):
        self.title = self.getField('File').getFilename(self)
        normal = self.plone_utils.normalizeString(self.title)
        id = normal
        if id != self.id:
            ids = self.aq_parent.objectIds()
            i = 1
            while id in ids:
                id = normal + '-' + str(i)
                i = i + 1
            self.aq_parent.manage_renameObject(id = self.id, new_id = id)
        getToolByName(self,'portal_catalog').reindexObject(self)
        #TODO iterate over fonts in /tmp and remove one that are not in ids

    def writeFont(self):
        fontFile = open('/tmp/' + self.id, 'w')
        fontFile.write('%s' % str(self.getField('File').getRaw(self)))
        fontFile.close()

    def at_post_create_script(self):
        self.setID()
        self.writeFont()

    def at_post_edit_script(self):
        self.setID()
        self.writeFont()

    def manage_beforeDelete(self, item, container):
        fontFileName = '/tmp/' + self.id
        if os.path.isfile(fontFileName):
            os.remove(fontFileName)
    ##/code-section class-header

    # Methods

registerType(Font,PROJECTNAME)
# end of class Font

##code-section module-footer #fill in your manual code here
##/code-section module-footer



